<?php

	switch( $lang['lang_short'] ) {
		case 'de':
			$lang['akismet_key'] = 'Akismet Key';
			break;
		case 'en':
		default:
			$lang['akismet_key'] = 'Akismet Key';
			break;
	}

	function akismet_check_comment()
	{
		global $comment, $entry, $config;

		if( empty( $config['akismet_key'] ) ) return;

		$akismet = new akismet( 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']), 'b1eb55ae55e2' );
		$akismet->setCommentAuthor( $comment['comment_author_name'] );
		$akismet->setCommentAuthorEmail( $comment['comment_author_mail'] );
		$akismet->setCommentAuthorURL( $comment['comment_author_url'] );
		$akismet->setCommentContent( $comment['comment_content'] );
		$akismet->setCommentType( 'comment' );
		$akismet->setPermalink( url( array( 'site' => 'blog', 'blog' =>  urlencode( $entry['entry_title'] ) ) ) );
		if( $akismet->isCommentSpam() ) {
			$comment['spam'] = 1;
		}
	}

	function akismet_check_trackback()
	{
		global $trackback, $entry, $config;

		
		if( empty( $config['akismet_key'] ) ) return;

		$akismet = new akismet( 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']), 'b1eb55ae55e2' );
		$akismet->setCommentAuthor( $trackback['blog_name'] );
		$akismet->setCommentAuthorURL( $trackback['url'] );
		$akismet->setCommentContent( $trackback['title'] . ' ' . $trackback['excerpt'] );
		$akismet->setCommentType( 'trackback' );
		$akismet->setPermalink( url( array( 'site' => 'blog', 'blog' =>  urlencode( $entry['entry_title'] ) ) ) );
		if( $akismet->isCommentSpam() ) {
			$trackback['spam'] = 1;
		}

	}

	function akismet_admin_settings_check()
	{
		global $settings_save;
		if( isset( $_POST['akismet_key'] ) ) $settings_save['akismet_key'] = $_POST['akismet_key'];
	}

	function akismet_admin_settings_form()
	{
		global $config, $tpl, $lang;
		if( !isset( $config['akismet_key'] ) ) return;

		$tpl->part_load();
		$tpl->fillin_array( array(
			'S_SETTINGS_FORM' => $lang['akismet_key'],
			'I_SETTINGS_FORM' => '<input type="text" name="akismet_key" value="' . $config['akismet_key'] . '" />',
		) );
	}

	function akismet_admin_comment_toggle( $id = 1 )
	{
		global $db;
		if( empty( $config['akismet_key'] ) ) return;

		$sql = "SELECT c.comment_author_name, c.comment_author_mail, c.comment_author_url, comment_author_ip, c.comment_content, c.comment_spam, e.entry_title FROM c " . TABLE_COMMENTS . " LEFT JOIN e " . TABLE_BLOG . " ON ( e.entry_id = c.entry_id ) WHERE c.comment_id = '" . $id . "';";
		$res = $db->query( $sql );
		if( $db->numrows( $res ) ) {
			$row = $db->fetch( $res );

			$akismet = new akismet( 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']), 'b1eb55ae55e2' );
			$akismet->setCommentAuthor( $row['comment_author_name'] );
			if( !empty( $row['comment_author_mail'] ) ) $akismet->setCommentAuthorEmail( $row['comment_author_mail'] );
			if( !empty( $row['comment_author_url'] ) ) $akismet->setCommentAuthorURL( $row['comment_author_url'] );
			$akismet->setCommentContent( $row['comment_title'] . $row['comment_content'] );
			$akismet->setUserIP( $row['comment_author_ip'] );
			$akismet->setReferrer( '' );
			if( empty( $row['comment_title'] ) ) $akismet->setCommentType( 'comment' );
			else $akismet->setCommentType( 'trackback' );
			$akismet->setPermalink( url( array( 'site' => 'blog', 'blog' =>  urlencode( $entry['entry_title'] ) ) ) );
			
			if( $row['comment_spam'] ) $akismet->submitSpam();
			else $akismet->submitHam();
		}
	}

	$plug->addhook( 'hook_comment_validating', 'akismet_check_comment' );
	$plug->addhook( 'hook_trackback_validating', 'akismet_check_trackback' );
	$plug->addhook( 'hook_admin_settings_validating', 'akismet_admin_settings_check' );
	$plug->addhook( 'hook_admin_settings_form', 'akismet_admin_settings_form' );
	$plug->addhook( 'hook_admin_comments_spam', 'akismet_admin_comment_toggle' );

?>
